Index: java/main/src/main/java/com/framsticks/params/ReflectionAccessBackend.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ReflectionAccessBackend.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/ReflectionAccessBackend.java	(revision 101)
@@ -0,0 +1,245 @@
+package com.framsticks.params;
+
+import java.lang.reflect.Field;
+import java.lang.reflect.InvocationTargetException;
+import java.lang.reflect.Method;
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.Comparator;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import javax.annotation.concurrent.Immutable;
+
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.types.EventParam;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.lang.Pair;
+
+
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+
+import static com.framsticks.util.lang.Containers.*;
+
+@Immutable
+public class ReflectionAccessBackend {
+
+	private final static Logger log = LogManager.getLogger(ReflectionAccessBackend.class.getName());
+
+	protected static final Map<Pair<Class<?>, FramsClass>, ReflectionAccessBackend> synchronizedCache = Collections.synchronizedMap(new HashMap<Pair<Class<?>, FramsClass>, ReflectionAccessBackend>());
+
+
+	public interface ReflectedGetter {
+		public <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
+	}
+
+	public interface ReflectedSetter {
+		public <T> void set(Object object, T value) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
+	}
+
+	public interface ReflectedCaller {
+		public Object call(Object object, Object[] arguments) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
+	}
+
+	public interface ReflectedAdder{
+		public void reg(Object object, EventListener<?> listener) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
+	}
+
+	public interface ReflectedRemover{
+		public void regRemove(Object object, EventListener<?> listener) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
+	}
+
+	protected final Map<String, ReflectedSetter> setters = new HashMap<>();
+	protected final Map<String, ReflectedGetter> getters = new HashMap<>();
+	protected final Map<String, ReflectedCaller> callers = new HashMap<>();
+	protected final Map<String, ReflectedAdder> adders = new HashMap<>();
+	protected final Map<String, ReflectedRemover> removers = new HashMap<>();
+
+	protected final List<Method> autoAppendMethods = new ArrayList<>();
+
+	/**
+	 * @param params
+	 */
+	public ReflectionAccessBackend() {
+	}
+
+	public static ReflectionAccessBackend getOrCreateFor(Class<?> reflectedClass, FramsClass framsClass) {
+
+		Pair<Class<?>, FramsClass> id = new Pair<Class<?>, FramsClass>(reflectedClass, framsClass);
+		ReflectionAccessBackend backend = synchronizedCache.get(id);
+		if (backend != null) {
+			return backend;
+		}
+
+		log.debug("constructing backend for {}", id);
+		backend = new ReflectionAccessBackend();
+
+		Map<String, ParamCandidate> candidates = ParamCandidate.getAllCandidates(reflectedClass).getCandidates();
+
+		try {
+			for (final ProcedureParam pp : filterInstanceof(framsClass.getParamEntries(), ProcedureParam.class)) {
+				if (!candidates.containsKey(pp.getId())) {
+					log.trace("java class does implement method {}", pp);
+					continue;
+				}
+				ParamCandidate pc = candidates.get(pp.getId());
+				final Method method = pc.getCaller();
+
+				backend.callers.put(pp.getId(), new ReflectedCaller() {
+
+					@Override
+					public Object call(Object object, Object[] arguments) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
+						return method.invoke(object, arguments);
+					}
+				});
+
+			}
+
+			for (final EventParam ep : filterInstanceof(framsClass.getParamEntries(), EventParam.class)) {
+				if (!candidates.containsKey(ep.getId())) {
+					log.trace("java class does not implement the event param {}", ep);
+					continue;
+				}
+				ParamCandidate ec = candidates.get(ep.getId());
+				final Method adder = ec.getAdder();
+				final Method remover = ec.getRemover();
+
+				backend.adders.put(ep.getId(), new ReflectedAdder() {
+
+					@Override
+					public void reg(Object object, EventListener<?> listener) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
+						adder.invoke(object, listener);
+					}
+				});
+
+				backend.removers.put(ep.getId(), new ReflectedRemover() {
+
+					@Override
+					public void regRemove(Object object, EventListener<?> listener) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
+						remover.invoke(object, listener);
+					}
+				});
+			}
+
+			for (final ValueParam vp : filterInstanceof(framsClass.getParamEntries(), ValueParam.class)) {
+				if (!candidates.containsKey(vp.getId())) {
+					throw new ConstructionException().msg("missing candidate for param").arg("param", vp);
+				}
+				ParamCandidate pc = candidates.get(vp.getId());
+				if (pc.isReadOnly() && !vp.hasFlag(ParamFlags.READONLY)) {
+					throw new ConstructionException().msg("readonly state conflict").arg("param", vp);
+				}
+				if (!typeMatch(pc.getRawType(), vp.getStorageType())) {
+					throw new ConstructionException().msg("types mismatch for param").arg("param", vp).arg("candidate", pc.getType()).arg("storage", vp.getStorageType());
+				}
+
+				final boolean primitive = pc.isPrimitive();
+				if (pc.getField() != null) {
+					final Field f = pc.getField();
+					backend.getters.put(vp.getId(), new ReflectedGetter() {
+						@Override
+						public <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException {
+							return type.cast(f.get(object));
+						}
+					});
+					if (!pc.isFinal()) {
+						backend.setters.put(vp.getId(), new ReflectedSetter() {
+							@Override
+							public <T> void set(Object object, T value) throws IllegalArgumentException, IllegalAccessException {
+								if (value == null && primitive) {
+									throw new FramsticksException().msg("setting null to primitive value");
+								}
+								f.set(object, value);
+							}
+						});
+					}
+				} else {
+					final Method g = pc.getGetter();
+
+					backend.getters.put(vp.getId(), new ReflectedGetter() {
+						@Override
+						public <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
+							return type.cast(g.invoke(object));
+						}
+					});
+
+					if (!pc.isFinal()) {
+						final Method s = pc.getSetter();
+						backend.setters.put(vp.getId(), new ReflectedSetter() {
+							@Override
+							public <T> void set(Object object, T value) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
+								if (value == null && primitive) {
+									throw new FramsticksException().msg("setting null to primitive value");
+								}
+								s.invoke(object, value);
+							}
+						});
+					}
+				}
+			}
+		} catch (ConstructionException e) {
+			throw e.arg("java class", reflectedClass).arg("framsClass", framsClass);
+		}
+
+		Class<?> javaClass = reflectedClass;
+		while (javaClass != null) {
+
+			for (Method m : javaClass.getDeclaredMethods()) {
+				AutoAppendAnnotation a = m.getAnnotation(AutoAppendAnnotation.class);
+				if (a == null) {
+					continue;
+				}
+				Class<?>[] args = m.getParameterTypes();
+				if (args.length != 1) {
+					throw new ConstructionException().msg("invalid number of arguments in AutoAppend marked method").arg("method", m).arg("arguments", args.length);
+				}
+				backend.autoAppendMethods.add(m);
+			}
+
+			javaClass = javaClass.getSuperclass();
+		}
+
+		Collections.sort(backend.autoAppendMethods, new Comparator<Method>() {
+
+			@Override
+			public int compare(Method m0, Method m1) {
+				Class<?> arg0 = m0.getParameterTypes()[0];
+				Class<?> arg1 = m1.getParameterTypes()[0];
+				if (arg0.isAssignableFrom(arg1)) {
+					return 1;
+				}
+				if (arg1.isAssignableFrom(arg0)) {
+					return -1;
+				}
+				return 0;
+			}
+		});
+
+		synchronizedCache.put(id, backend);
+		return backend;
+	}
+
+	public static boolean typeMatch(Class<?> a, Class<?> b) {
+		if (b.isPrimitive()) {
+			throw new FramsticksException().msg("failed to match type, right argument is primitive").arg("left", a).arg("right", b);
+		}
+		if (!a.isPrimitive()) {
+			return a.equals(b);
+		}
+
+		if (a.equals(int.class)) {
+			return b.equals(Integer.class);
+		}
+		if (a.equals(double.class)) {
+			return b.equals(Double.class);
+		}
+		if (a.equals(boolean.class)) {
+			return b.equals(Boolean.class);
+		}
+		throw new FramsticksException().msg("failed to match types").arg("left", a).arg("right", b);
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/params/Registry.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Registry.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/params/Registry.java	(revision 101)
@@ -8,4 +8,5 @@
 import com.framsticks.util.DoubleMap;
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.FramsticksUnsupportedOperationException;
 import com.framsticks.util.lang.Strings;
 
@@ -20,5 +21,5 @@
  */
 @FramsClassAnnotation
-public class Registry {
+public class Registry implements AccessProvider {
 	private static final Logger log = LogManager.getLogger(Registry.class.getName());
 
@@ -45,7 +46,10 @@
 
 	public Registry registerAndBuild(Class<?> javaClass) {
+		if (javaToFramsAssociation.containsKey(javaClass)) {
+			return this;
+		}
 		register(javaClass);
 		associate(javaClass, putFramsClass(FramsClass.build().forClass(javaClass)));
-		for (Class<?> r : javaClass.getAnnotation(FramsClassAnnotation.class).register()) {
+		for (Class<?> r : ParamCandidate.getAllCandidates(javaClass).getDependentClasses()) {
 			registerAndBuild(r);
 		}
@@ -157,3 +161,13 @@
 	}
 
+	@Override
+	public Access getAccess(String name) {
+		return createAccess(name);
+	}
+
+	@Override
+	public void addAccess(Access access) {
+		throw new FramsticksUnsupportedOperationException().msg("adding accesses to Registry");
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 101)
@@ -4,10 +4,7 @@
 import static com.framsticks.util.lang.Containers.filterInstanceof;
 
-import org.apache.logging.log4j.Logger;
-import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.params.types.ObjectParam;
 import com.framsticks.util.FramsticksException;
-import static com.framsticks.params.SetStateFlags.*;
 
 /**
@@ -23,7 +20,5 @@
  * @author Piotr Sniegowski
  */
-public abstract class SimpleAbstractAccess implements Access {
-
-	private final static Logger log = LogManager.getLogger(SimpleAbstractAccess.class.getName());
+public abstract class SimpleAbstractAccess implements ObjectAccess {
 
 	protected final FramsClass framsClass;
@@ -40,24 +35,4 @@
 		return framsClass;
 	}
-
-	/**
-	 * Simple String key, value class.
-	 */
-	public static class Entry {
-
-		public final String key;
-		public final String value;
-
-		public Entry(String key, String value) {
-			this.key = key;
-			this.value = value;
-		}
-
-		@Override
-		public String toString() {
-			return key + " = " + value;
-		}
-	}
-
 
 	@Override
@@ -129,51 +104,4 @@
 
 	@Override
-	public void setDefault(boolean numericOnly) {
-		for (int i = 0; i < framsClass.getParamCount(); i++) {
-			setDefault(i, numericOnly);
-		}
-	}
-
-	@Override
-	public void setDefault(int i, boolean numericOnly) {
-		ValueParam entry = framsClass.getParamEntry(i, ValueParam.class);
-		if ((entry != null)	&& (!numericOnly || entry.isNumeric())) {
-			set(i, entry.getDef(entry.getStorageType()));
-		}
-	}
-
-	@Override
-	public void setMin() {
-		for (int i = 0; i < framsClass.getParamCount(); i++) {
-			setMin(i);
-		}
-	}
-
-	@Override
-	public void setMin(int i) {
-		PrimitiveParam<?> entry = framsClass.getParamEntry(i, PrimitiveParam.class);
-		Object min = entry.getMin(entry.getStorageType());
-		if (min != null) {
-			set(i, min);
-		}
-	}
-
-	@Override
-	public void setMax() {
-		for (int i = 0; i < framsClass.getParamCount(); i++) {
-			setMax(i);
-		}
-	}
-
-	@Override
-	public void setMax(int i) {
-		PrimitiveParam<?> entry = framsClass.getParamEntry(i, PrimitiveParam.class);
-		Object max = entry.getMax(entry.getStorageType());
-		if (max != null) {
-			set(i, max);
-		}
-	}
-
-	@Override
 	public void save(SinkInterface sink) {
 		assert framsClass != null;
@@ -189,62 +117,4 @@
 		}
 		sink.breakLine();
-	}
-
-	private static Entry readEntry(SourceInterface source) {
-
-		String line;
-		String key = null;
-		StringBuilder value = null;
-		while ((line = source.readLine()) != null) {
-			if (key == null) {
-				int colonIndex = line.indexOf(':');
-				if (colonIndex == -1) {
-					return null;
-				}
-				key = line.substring(0, colonIndex);
-				String inlineValue = line.substring(colonIndex + 1);
-
-
-				if (!inlineValue.startsWith("~")) {
-					return new Entry(key, inlineValue);
-				}
-				value = new StringBuilder();
-				value.append(inlineValue.substring(1));
-				continue;
-			}
-			if (value.length() != 0) {
-				value.append(System.getProperty("line.separator"));
-			}
-			if (line.endsWith("~") && !line.endsWith("\\~")) {
-				value.append(line.substring(0, line.length() - 1));
-				return new Entry(key, value.toString().replaceAll("\\\\~", "~"));
-			}
-			value.append(line);
-		}
-		return null;
-	}
-
-	@Override
-	public void load(SourceInterface source) {
-		//TODO not clearing values, because get from manager gives only fields, not children
-		//this.clearValues();
-
-		Entry entry;
-		while ((entry = readEntry(source)) != null) {
-			Param param = getParam(entry.key);
-			if (param == null) {
-				throw new FramsticksException().msg("param not found in access").arg("name", entry.key).arg("access", this);
-			}
-			if (!(param instanceof ValueParam)) {
-				throw new FramsticksException().msg("param is not a value param").arg("param", param).arg("access", this);
-			}
-			if ((param.getFlags() & ParamFlags.DONTLOAD) == 0) {
-				int retFlags = this.set((ValueParam) param, entry.value);
-				if ((retFlags & (PSET_HITMIN | PSET_HITMAX)) != 0) {
-					String which = ((retFlags & PSET_HITMIN) != 0) ? "small" : "big";
-					log.warn("value of key '{}' was too {}, adjusted", entry.key, which);
-				}
-			}
-		}
 	}
 
@@ -266,23 +136,4 @@
 	}
 
-	/*
-	protected <T extends Comparable<T>> int setAndCut(Param param, Object value, Class<T> type) {
-		int flags = 0;
-		T val = type.cast(value);
-		T min = param.getMin(type);
-		T max = param.getMax(type);
-		if (min != null && val.compareTo(min) < 0) {
-			val = min;
-			flags |= Flags.PSET_HITMIN;
-		}
-		if (max != null && val.compareTo(max) > 0) {
-			val = max;
-			flags |= Flags.PSET_HITMAX;
-		}
-		internalSet(param, val);
-		return flags;
-	}*/
-
-
 	@Override
 	public ParamBuilder buildParam(ParamBuilder builder) {
Index: java/main/src/main/java/com/framsticks/params/SimpleUniqueList.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/SimpleUniqueList.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/SimpleUniqueList.java	(revision 101)
@@ -0,0 +1,71 @@
+package com.framsticks.params;
+
+import java.util.Collections;
+import java.util.Iterator;
+import java.util.Map;
+
+import com.framsticks.core.ListChange;
+
+public class SimpleUniqueList<T extends UniqueObject> implements Iterable<T> {
+
+	protected final Map<String, T> children;
+	protected final Class<T> type;
+	protected final char prefix;
+	protected final EventListeners<ListChange> listeners = new EventListeners<>();
+
+	protected int counter = 0;
+
+	/**
+	 * @param type
+	 */
+	public SimpleUniqueList(Class<T> type, char prefix) {
+		this.type = type;
+		this.prefix = prefix;
+		children = UniqueListAccess.createMap(type, this);
+	}
+
+	// public static <T2> SimpleUniqueList<T2> make(Class<T2> type) {
+	//	return new SimpleUniqueList<T2>(type);
+	// }
+
+	public String generateId() {
+		return prefix + Integer.toString(counter++);
+	}
+
+	@Override
+	public Iterator<T> iterator() {
+		return children.values().iterator();
+	}
+
+	public void addListener(EventListener<ListChange> listener) {
+		listeners.add(listener);
+	}
+
+	public void removeListener(EventListener<ListChange> listener) {
+		listeners.remove(listener);
+	}
+
+	public void fireChildrenChange(T child, ListChange.Action action) {
+		ListChange change = new ListChange(action, UniqueListAccess.getNumberInMap(children, child), child.getUid());
+		listeners.actionForAll(change);
+	}
+
+	public void add(T child) {
+		child.setUid(generateId());
+		children.put(child.getUid(), child);
+		fireChildrenChange(child, ListChange.Action.Add);
+	}
+
+	public void remove(T child) {
+		fireChildrenChange(child, ListChange.Action.Remove);
+		children.remove(child.getUid());
+	}
+
+	public void modify(T child) {
+		fireChildrenChange(child, ListChange.Action.Modify);
+	}
+
+	public Map<String, T> getView() {
+		return Collections.unmodifiableMap(children);
+	}
+}
Index: java/main/src/main/java/com/framsticks/params/Source.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Source.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/Source.java	(revision 101)
@@ -0,0 +1,10 @@
+package com.framsticks.params;
+
+public interface Source {
+	String getFilename();
+	String readLine();
+	String demangleInclude(String include);
+	Source openInclude(String include);
+	void close();
+	boolean isClosed();
+}
Index: java/main/src/main/java/com/framsticks/params/UniqueListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 101)
@@ -4,5 +4,5 @@
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.UnimplementedException;
-import com.framsticks.util.UnsupportedOperationException;
+import com.framsticks.util.FramsticksUnsupportedOperationException;
 import com.framsticks.util.lang.Casting;
 import com.framsticks.util.lang.Numbers;
@@ -205,5 +205,5 @@
 	@Override
 	public <T> int set(int i, T value) {
-		throw new UnsupportedOperationException().msg("accesing unique list through index");
+		throw new FramsticksUnsupportedOperationException().msg("accesing unique list through index");
 	}
 
@@ -251,5 +251,5 @@
 	@Override
 	public UniqueListAccess select(Object object) {
-		map = Util.selectObjectForAccess(this, object, Map.class);
+		map = ParamsUtil.selectObjectForAccess(this, object, Map.class);
 		return this;
 	}
Index: java/main/src/main/java/com/framsticks/params/UniqueObject.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/UniqueObject.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/UniqueObject.java	(revision 101)
@@ -0,0 +1,8 @@
+package com.framsticks.params;
+
+public interface UniqueObject {
+
+	public String getUid();
+
+	public void setUid(String uid);
+}
Index: java/main/src/main/java/com/framsticks/params/annotations/ParamAnnotation.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/annotations/ParamAnnotation.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/params/annotations/ParamAnnotation.java	(revision 101)
@@ -22,5 +22,5 @@
 
 	String help() default "";
-	// int flags() default 0;
+	int flags() default 0;
 	int extra() default 0;
 	// String group() default "";
Index: java/main/src/main/java/com/framsticks/parsers/AccessStash.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/AccessStash.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/parsers/AccessStash.java	(revision 101)
@@ -0,0 +1,24 @@
+package com.framsticks.parsers;
+
+import java.util.HashMap;
+import java.util.Map;
+
+import com.framsticks.params.Access;
+import com.framsticks.params.AccessProvider;
+
+public class AccessStash implements AccessProvider {
+
+	protected final Map<String, Access> accesses = new HashMap<>();
+
+	@Override
+	public Access getAccess(String name) {
+		return accesses.get(name);
+	}
+
+	@Override
+	public void addAccess(Access access) {
+		/**TODO: by id or by name? rather by id, because from file is always lowercase*/
+		accesses.put(access.getId(), access);
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/parsers/F0Parser.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 101)
@@ -12,5 +12,4 @@
 import com.framsticks.model.f0.Schema;
 
-import static com.framsticks.params.SimpleAbstractAccess.*;
 
 import com.framsticks.params.Param;
@@ -26,4 +25,5 @@
 import com.framsticks.params.FramsClass;
 import com.framsticks.params.Access;
+import com.framsticks.params.AccessOperations.Entry;
 import static com.framsticks.params.ParamFlags.*;
 import static com.framsticks.params.SetStateFlags.*;
Index: java/main/src/main/java/com/framsticks/parsers/FileSource.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/FileSource.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/parsers/FileSource.java	(revision 101)
@@ -1,5 +1,5 @@
 package com.framsticks.parsers;
 
-import com.framsticks.params.SourceInterface;
+import com.framsticks.params.Source;
 import com.framsticks.util.io.Encoding;
 
@@ -7,5 +7,5 @@
 
 
-public class FileSource implements SourceInterface {
+public class FileSource implements Source {
 
 	private BufferedReader reader;
@@ -60,5 +60,5 @@
 
 	@Override
-	public SourceInterface openInclude(String include)
+	public Source openInclude(String include)
 	{
 		try
@@ -89,3 +89,8 @@
 	}
 
+	@Override
+	public String toString() {
+		return filename;
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/parsers/Loaders.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/Loaders.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/parsers/Loaders.java	(revision 101)
@@ -13,5 +13,5 @@
 	// private static final Logger log = LogManager.getLogger(Loaders.class.getName());
 
-	public static @Nonnull FramsClass loadFramsClass(SourceInterface source) throws ConstructionException {
+	public static @Nonnull FramsClass loadFramsClass(Source source) throws ConstructionException {
 		final MultiParamLoader loader = new MultiParamLoader();
 		loader.setNewSource(source);
Index: java/main/src/main/java/com/framsticks/parsers/MultiParamLoader.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/MultiParamLoader.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/parsers/MultiParamLoader.java	(revision 101)
@@ -68,5 +68,5 @@
 	 * File from which data should be read.
 	 */
-	private SourceInterface currentSource;
+	private Source currentSource;
 
 	protected String currentLine;
@@ -83,10 +83,10 @@
 	 * actual reader.
 	 */
-	private Map<String, SourceInterface> fileMap = new HashMap<String, SourceInterface>();
+	private Map<String, Source> fileMap = new HashMap<String, Source>();
 
 	/**
 	 * List of known classes.
 	 */
-	private Map<String, Access> knownParamInterfaces = new HashMap<String, Access>();
+	protected AccessProvider accessProvider = new AccessStash();
 
 	/**
@@ -100,4 +100,18 @@
 	public String getCurrentLine() {
 		return currentLine;
+	}
+
+	/**
+	 * @return the accessProvider
+	 */
+	public AccessProvider getAccessProvider() {
+		return accessProvider;
+	}
+
+	/**
+	 * @param accessProvider the accessProvider to set
+	 */
+	public void setAccessProvider(AccessProvider accessProvider) {
+		this.accessProvider = accessProvider;
 	}
 
@@ -184,5 +198,5 @@
 			}
 			log.trace("loading into {}", lastAccess);
-			lastAccess.load(currentSource);
+			AccessOperations.load(lastAccess, currentSource);
 
 			if (changeStatus(Status.AfterObject)) {
@@ -194,5 +208,5 @@
 
 			// found unknown object
-			emptyParam.load(currentSource);
+			AccessOperations.load(emptyParam, currentSource);
 			if (changeStatus(Status.AfterObject)) {
 				return LoopAction.Break;
@@ -262,5 +276,5 @@
 		if (line.charAt(line.length() - 1) == ':') {
 			String typeName = line.substring(0, line.length() - 1);
-			lastAccess = knownParamInterfaces.get(typeName);
+			lastAccess = accessProvider.getAccess(typeName);
 
 			if (lastAccess != null) {
@@ -300,6 +314,5 @@
 	 */
 	public void addAccess(Access access) {
-		/**TODO: by id or by name? rather by id, because from file is always lowercase*/
-		knownParamInterfaces.put(access.getId(), access);
+		accessProvider.addAccess(access);
 	}
 
@@ -324,5 +337,5 @@
 	 */
 
-	public boolean setNewSource(SourceInterface source) {
+	public boolean setNewSource(Source source) {
 		log.debug("switching current source to {}...", source.getFilename());
 
@@ -351,5 +364,5 @@
 		log.info("including file {}...", includeFilename);
 
-		SourceInterface newSource = currentSource.openInclude(includeFilename);
+		Source newSource = currentSource.openInclude(includeFilename);
 		if (newSource == null) {
 			return;
@@ -426,5 +439,5 @@
 	}
 
-	public static List<Object> loadAll(SourceInterface source, Access access) {
+	public static List<Object> loadAll(Source source, Access access) {
 		final List<Object> result = new LinkedList<>();
 
Index: java/main/src/main/java/com/framsticks/parsers/XmlLoader.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/XmlLoader.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/parsers/XmlLoader.java	(revision 101)
@@ -20,4 +20,6 @@
 
 import com.framsticks.params.Access;
+import com.framsticks.params.ParamFlags;
+import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.Registry;
 import com.framsticks.util.AutoBuilder;
@@ -107,5 +109,9 @@
 		for (int i = 0; i < attributes.getLength(); ++i) {
 			Node attributeNode = attributes.item(i);
-			access.set(mangleAttribute(attributeNode.getNodeName()), attributeNode.getNodeValue());
+			PrimitiveParam<?> param = access.getFramsClass().getParamEntry(mangleAttribute(attributeNode.getNodeName()), PrimitiveParam.class);
+			if (param.hasFlag(ParamFlags.READONLY)) {
+				throw new FramsticksException().msg("cannot configure readonly param").arg("param", param).arg("in", access);
+			}
+			access.set(param, attributeNode.getNodeValue());
 		}
 
